#include <iostream> 
#include <sstream> 
#include <cstdio> 
#include <cstdlib> 
#include <cmath> 
#include <memory> 
#include <cctype> 
#include <string> 
#include <vector> 
#include <list> 
#include <queue> 
#include <deque> 
#include <stack> 
#include <map> 
#include <set> 
#include <algorithm> 
using namespace std;
 
#define FOR(i,a,b) for(int (i) = (a); (i) < (b); ++(i))
#define RFOR(i,a,b) for(int (i) = (a)-1; (i) >= (b); --(i))
#define CLEAR(a) memset((a),0,sizeof(a))
#define INF 1000000000
#define PB push_back
#define ALL(c) (c).begin(), (c).end()
#define pi 2*acos(0.0)
#define SQR(a) (a)*(a)
#define MP make_pair
#define MAX 1000000000
 
typedef long long Int;
 
int n, m, k;
int C[128], R[128], DP[11][11][2], Z[128][10];
 
vector <int> F(int x)
{
		string s;
		stringstream ss;
		ss << x;
		ss >> s;
		CLEAR(DP);
		DP[0][0][1] = 1;
		FOR (i,0,s.size())
				FOR (j,0,10)
						FOR (k,0,2)
						{
								if (DP[i][j][k] == 0)
										continue;
								FOR (d,0,10)
								{
										int jj = j;
										if (d == 4 || d == 7)
												jj++;
										int kk = k;
										if (k == 1)
										{
												if (d < (s[i]-'0'))
														kk = 0;
												else
												if (d > (s[i]-'0'))
														continue;
										}
										DP[i+1][jj][kk] += DP[i][j][k];
								}
						}
		vector <int> T;
		FOR (i,0,10)
				T.PB(DP[s.size()][i][0] + DP[s.size()][i][1]);
		T[0]--;
		return T;
}
 
int Count(int x)
{
		int c = 0;
		while (x > 0)
		{
				if ((x % 10 == 4) || (x % 10 == 7))
						c++;
				x /= 10;
		}
		return c;
}
 
int F(int pos, int x)
{
		vector <int> A;
		vector <int> B;
		A = F(x);
		B = F(m);
		CLEAR(Z);
		FOR (i,0,10)
		{
				if (pos == 0)
						Z[pos][i] = A[i];
				else
				{
						if (C[pos-1] == 1 && i != Count(R[pos-1]))
								continue;
						if (C[pos-1] == 0 && i == Count(R[pos-1]))
								continue;
						Z[pos][i] = A[i];
				}
		}
		FOR (i,pos,n-1)
				FOR (j,0,10)
				{
						if (Z[i][j] == 0)
								continue;
						FOR (k,0,10)
						{
								if (C[i] == 1 && j != k)
										continue;
								if (C[i] == 0 && j == k)
										continue;
								Int t = Z[i][j];
								t = t*B[k];
								if (t > MAX)
										t = MAX+1;
								Z[i+1][k] += t;
								if (Z[i+1][k] > MAX)
										Z[i+1][k] = MAX+1;
						}
				}
		int res = 0;
		FOR (i,0,10)
		{
				res += Z[n-1][i];
				if (res > MAX)
						res = MAX+1;
		}
		return res;
}
 
 
int t;
 
int main()
{
		cin >> t;
		FOR (tt,0,t)
		{
				cin >> n >> m >> k;
				FOR (i,0,n-1)
				{
						cin >> C[i];
				}
				bool ok = true;
				FOR (i,0,n)
				{
						int l = 1, r = m;
						while (l < r)
						{
								int e = (l+r)/2;
								int f = F(i, e);
								if (f >= k)
										r = e;
								else
										l = e+1;
						}
						R[i] = l;
						int f = F(i, l);
						if (f < k || l < 0 || l > m)
						{
								ok = false;
								break;
						}
						l--;
						k -= F(i, l);						
				}		
				if (!ok)
				{
						cout << -1 << endl;
				}
				else
				{
						FOR (i,0,n)
								cout << R[i] << ' ';
						cout << endl;
				}
		}
		return 0;
}  